package com.engine.thinktrans.service;

import com.engine.thinktrans.entity.param.PersonnelSizeTopParam;
import com.engine.thinktrans.entity.param.TendencyReportParam;
import com.engine.thinktrans.entity.vo.TendencyReportVO;

import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2023/11/16 10:43 AM
 * @Description: TODO
 * @Version 1.0
 */
public interface ReportCollectService {

    /**
     * @Description: 年度人力趋势报表
     * @Author: liang.cheng
     * @Date: 2023/11/16 2:39 PM
     * @param: []
     * @return: com.engine.thinktrans.entity.vo.TendencyReportVO
     */
    TendencyReportVO getPersonTendency(TendencyReportParam tendencyReportParam);

    /**
     * @Description: 实时在职人数
     * @Author: liang.cheng
     * @Date: 2023/11/20 10:05 AM
     * @param: [param]
     * @return: com.engine.thinktrans.entity.vo.TendencyReportVO
     */
    TendencyReportVO getOnJobStatistics();

    /**
     * @Description: 公司人员规模分析表
     * @Author: liang.cheng
     * @Date: 2023/11/22 10:11 AM
     * @param: [year]
     * @return: com.engine.thinktrans.entity.vo.TendencyReportVO
     */
    TendencyReportVO getPersonnelSize(PersonnelSizeTopParam param);

    /**
     * @Description: 公司人员规模分析表顶部
     * @Author: liang.cheng
     * @Date: 2023/11/22 2:30 PM
     * @param: [integer]
     * @return: Map<String,Object>
     */
    Map<String,Object> getTop(PersonnelSizeTopParam param);
}
