package com.engine.thinktrans.service.impl;

import com.engine.core.impl.Service;
import com.engine.thinktrans.service.CubeRecordDataService;
import com.engine.thinktrans.util.CommonDateUtil;
import com.weaver.general.Util;
import lombok.SneakyThrows;
import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.hrm.company.DepartmentComInfo;

import java.time.YearMonth;
import java.util.*;

/**
 * @Author liang.cheng
 * @Date 2023/11/20 3:48 PM
 * @Description: TODO
 * @Version 1.0
 */
public class CubeRecordDataServiceImpl extends Service implements CubeRecordDataService {


    @Override
    public Map<String, Object> dimissionRate(Integer year) {
        RecordSet rs = new RecordSet();
        Map<String, Object> result = new HashMap<>(2);

        List<List> datas = new ArrayList<>();
        List<Integer> deptList = new ArrayList<>();
        rs.executeQuery("select a.deptid from hrmdepartmentdefined a left join hrmdepartment b on a.deptid =b.id where a.bmcj in (0,1)" +
                " and (b.canceled = 0 or b.canceled is null)");
        while (rs.next()) {
            deptList.add(Util.getIntValue(rs.getString("deptid")));
        }

        // 合计
        deptList.add(-9999);

        deptList.forEach(id -> {
            List<Object> yearList = getYearData(year,id);
            datas.add(yearList);
        });

        if (datas.size() > 0) {
            rs.executeUpdate("delete from uf_lzlbb where nf = ?",year);
            rs.executeBatchSql("insert into uf_lzlbb(bmmc,nf,bmmc1,lzrs1,zrl1,lzl1,lzrs2,zrl2,lzl2,lzrs3,zrl3,lzl3,lzrs4,zrl4,lzl4,lzrs5,zrl5,lzl5," +
                    " lzrs6,zrl6,lzl6,lzrs7,zrl7,lzl7,lzrs8,zrl8,lzl8,lzrs9,zrl9,lzl9,lzrs10,zrl10,lzl10,lzrs11,zrl11,lzl11,lzrs12,zrl12,lzl12) " +
                    " values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", datas);
        }

        result.put("count",datas.size());
        return result;
    }

    @SneakyThrows
    private List<Object> getYearData(Integer year, Integer id) {
        RecordSet rs = new RecordSet();
        DepartmentComInfo departmentComInfo = new DepartmentComInfo();
        List<Object> data = new ArrayList<>();
        data.add(id);
        data.add(year);
        ArrayList<String> allSubDepartment = new ArrayList<>();
        List<YearMonth> yearMonths = CommonDateUtil.getYearMonths(year);

        StringBuilder st = new StringBuilder();
        st.append("select count(1) as sum from hrmresource where companystartdate <= ? ");

        StringBuilder sql = new StringBuilder();
        sql.append("select count(1) as dimension from hrmstatushistory h left join hrmresource s on h.resourceid = s.id where h.type_n = 5 " +
                " and h.changedate >= ? and h.changedate <= ? ");

        if (id != -9999) {
            data.add(departmentComInfo.getDepartmentName(String.valueOf(id)));
            departmentComInfo.getAllChildDeptByDepId(allSubDepartment, String.valueOf(id));
            allSubDepartment.add(String.valueOf(id));
            String allId = StringUtils.join(allSubDepartment, ",");
            st.append(" and departmentid in (").append(allId).append(")");
            sql.append("  and s.departmentid in (").append(allId).append(")");
        }else {
            data.add("合计");
        }


        for (YearMonth yearMonth : yearMonths) {
            int dimension = 0;
            int sum = 0;
            String startMonth = CommonDateUtil.getFormatYear(CommonDateUtil.toDateStartOfMonth(YearMonth.now()));
            String endMonth = CommonDateUtil.getFormatYear(CommonDateUtil.toDateEndOfMonth(yearMonth));
            rs.executeQuery(st.toString(), endMonth);
            if (rs.next()) {
                sum = Util.getIntValue(rs.getString("sum"));
            }
            rs.executeQuery(sql.toString(), startMonth, endMonth);
            if (rs.next()) {
                dimension = Util.getIntValue(rs.getString("dimension"));
            }
            float result = sum == 0 ? 0 : ((float)dimension) / sum;
            double rate = sum == 0 ? 0 : Math.round(result * 100.0) / 100.0;
            data.add(dimension);
            data.add(sum);
            data.add(rate);

        }
        return data;
    }
}
